#!/usr/bin/env perl

use strict;
use warnings;

use Time::HiRes qw( usleep );

#use DateTime;
#use DateTime::Format::Strptime;
#
#my $tz = DateTime::TimeZone->new(name => 'local');
#
##my $st = DateTime->new('2019-11-29T07:22:31.751');
##my $et = DateTime->new('2019-11-29T07:22:32.751');
#
##my $st = DateTime->new(year => 2019, month => 11, day => 29,
##		     hour => 07, minute => 22, second => 31,
##		       nanosecond => 751);
##my $et = DateTime->new(year => 2019, month => 11, day => 29,
##		     hour => 07, minute => 22, second => 32,
##		       nanosecond => 751);
#
#my $strp = DateTime::Format::Strptime->new(pattern => '%T',);
#my $sstr = '2019-11-29T07:22:31.751';
#my $estr = '2019-11-29T07:22:32.751';
##
#my $st = $strp->parse_datetime($sstr);
#my $et = $strp->parse_datetime($estr);
#
##my $diff = $et - $st;
##my $diff = $et->subtract_datetime($st);
#my $diff = $et->delta_ms($st);
##print $diff->seconds, "\n";

my $current = "";
my $next = "";

my $input_file;
my $output_file;
my $fh;

if ($#ARGV == 0) {
    $input_file = $ARGV[0];
    $fh = *STDOUT;
    die "Can't open $input_file: $!" unless open(FD, "<", "$input_file");
}
elsif ($#ARGV == 1) {
    $input_file = $ARGV[0];
    $output_file = $ARGV[1];
    die "Can't open $input_file: $!" unless open(FD, "<", "$input_file");
    die "Can't open $output_file: $!" unless open(EX, ">", "$output_file");
    $fh = *EX;
}
else {
    die "Usage: ./feed.pl input_csv_file.csv [output_csv_file.csv]";
}

print "input = $input_file, output = $output_file\n";

my $line = <FD>;
#print EX $line;
print $fh $line;
$line = <FD>;
#print EX $line;
print $fh $line;
$line = <FD>;
#print EX $line;
print $fh $line;

my @line;
my $going = 1;
my $wait = 1;

my $par_count = 0;

while(1) {
    $line = <FD>;
    last unless $line;
    if ($line =~ m/^EV/) {
	@line = split(/,/, $line);
	my $obt = $line[1];
	if ($current eq "") {
	    # Write current line to file
	    print $fh $line;
	    flush $fh;
	    # Set current_datetime to obt
	    #$current = $strp->parse_datetime($obt);
###	    sleep 2;
	}
	else {
	    
	}
	next;
    }

    if ($line =~ m/^TMPAR/) {
	print $fh $line;
	flush $fh;
	$wait = 1;
	#sleep 1;
	++$par_count;
	next;
    }

    if ($line =~ m/^TM,/) {
#	sleep 1 if $wait;
	usleep(500000) if $wait;
#	usleep(400000) if $wait;
#	usleep(250000) if $wait;
	print $fh $line;
	flush $fh;
	@line = split(/,/, $line);
	print "OBT: $line[11]\t$par_count\n";
	$par_count = 0;
	next;
    }

    if ($line =~ m/^TC,/) {
#	sleep 1 if $wait;
	usleep(500000) if $wait;
#	usleep(400000) if $wait;
#	usleep(250000) if $wait;
	print $fh $line;
	flush $fh;
	print "LINE: $line";
	next;
    }

}
close $fh;
close FD;

